// EQTxPacket.h

#ifndef __EQTxPacket_h__
#define __EQTxPacket_h__

//#include "DatagramPacket.h"
#include "EQPacket.h"
#include <string.h>
#include "XTime.h"


class CEQTxPacket : public CDatagramPacket
{
private:
	CXTime m_timeSent;

public:
	// construct a non-SEQ packet
	CEQTxPacket(
		unsigned short header,
		unsigned short packetID,
		unsigned short ackID,
		const void* pData,
		size_t dataSize);
/*
	CEQTxPacket(
		unsigned short header,
		unsigned short packetID,
		unsigned short ackID,
		unsigned short sequenceID,
		unsigned char messageID,
		const void* pData,
		size_t dataSize);*/

	// construct a SEQ packet
	CEQTxPacket(
		unsigned short header,
		unsigned short packetID,
		unsigned short sequenceID,
		unsigned short ackID,
		unsigned short fragID,
		unsigned short fragIndex,
		unsigned short maxFragIndex,
		unsigned char messageID,
		const void* pData,
		size_t dataSize);

	void setPacketID(unsigned short newPacketID)
	{
		CEQPacket::FillWord((unsigned char *)getData().getData(), 2, newPacketID);
	}

	unsigned short getSequenceID()
	{
		return CEQPacket::GetWord((unsigned char *)getData().getData(), 4);
	}

	bool needsACK()
	{
		unsigned short flags = CEQPacket::GetWord((unsigned char *)getData().getData(), 0);

		// don't wait for ACK and resend heartbeat packets.
		return (flags & EQ_MSG_SEQ) && !(flags & EQ_MSG_SYS) ?
			true : false;
	}

	void setTimeSent()
	{
		m_timeSent.reset();
	}

	CXTime &getTimeSent()
	{
		return m_timeSent;
	}

private:
	void init(
		size_t headerSize,
		const void* pData,
		size_t dataSize);
};

#endif // __EQTxPacket_h__